# BMA Server Framework: core::ConsoleSession Class Reference

core::ConsoleSession Class Reference

`#include <ConsoleSession.h>`

Inheritance diagram for core::ConsoleSession:
[legend]
Collaboration diagram for core::ConsoleSession:
[legend]

## Public Member Functions

| ConsoleSession (EPoll &ePoll, ConsoleServer &server)
virtual void | output (std::stringstream &out)
void | writeLog (std::string data)
Public Member Functions inherited from core::TerminalSession
| TerminalSession (EPoll &ePoll, TCPServerSocket &server)
int | getLines ()
void | clear ()
void | clearEOL ()
void | setCursorLocation (int x, int y)
void | setColor (int color)
void | setBackColor (int color)
void | saveCursor ()
void | restoreCursor ()
void | NextLine (int lines)
void | PreviousLine (int lines)
void | scrollArea (int start, int end)
Public Member Functions inherited from core::Session
| Session (EPoll &ePoll, TCPServerSocket &server)
virtual void | init ()
virtual void | output (Session *session)
void | send ()
void | sendToAll ()
void | sendToAll (SessionFilter *filter)
TCPServerSocket & | getServer ()
Public Member Functions inherited from core::TCPSocket
| TCPSocket (EPoll &ePoll)
void | connect (IPAddress &address)
Public Member Functions inherited from core::Socket
| Socket (EPoll &ePoll)
void | setDescriptor (int descriptor)
| Set the descriptor for the socket.
int | getDescriptor ()
| Get the descriptor for the socket.
void | eventReceived (struct epoll_event event)
| Parse epoll event and call specified callbacks. More...
void | write (std::string data)
void | write (char *buffer, int length)
void | output (std::stringstream &out)
virtual void | onRegistered ()
| Called when the socket has finished registering with the epoll processing. More...
virtual void | onUnregistered ()
| Called when the socket has finished unregistering for the epoll processing. More...
void | enable (bool mode)
| Enable the socket to read or write based upon buffer.

## Protected Member Functions

void | protocol (std::string data) override
Protected Member Functions inherited from core::Session
void | onDataReceived (std::string data) override
| Called when data is received from the socket. More...
void | onConnected () override
| Called when socket is open and ready to communicate. More...
Protected Member Functions inherited from core::Socket
void | setBufferSize (int length)
virtual void | onTLSInit ()
void | shutdown ()
virtual void | receiveData (char *buffer, int bufferLength)

## Additional Inherited Members

Public Attributes inherited from core::Session
std::stringstream | out
TCPServerSocket & | server
Public Attributes inherited from core::TCPSocket
IPAddress | ipAddress
Public Attributes inherited from core::Socket
class {
} | bufferSize
Public Attributes inherited from core::Object
std::string | name
std::string | tag
Protected Attributes inherited from core::Socket
EPoll & | ePoll
bool | shutDown = false

## Detailed Description

ConsoleSession

Extends the session parameters for this TCPSocket derived object. Extend the protocol() method in order to define the behavior and protocol interaction for this socket which is a console session.

## Member Function Documentation

## output()

void core::ConsoleSession::output | ( | std::stringstream & | out | ) |

virtual

The output method is called by a socket session (BMASession) and will output the detail information for the client socket. When extending BMATCPSocket or BMASession you can override the method to add attributes to the list.

Reimplemented from core::TCPSocket.

The documentation for this class was generated from the following files:

- /home/barant/Development/BMA/server_core/ServerCore/ConsoleSession.h
- /home/barant/Development/BMA/server_core/ServerCore/ConsoleSession.cpp